/* $Id: chips.h,v 1.3 1998/11/02 04:38:45 brian Exp $
******************************************************************************

   Chips & Technologies register definitions and structures

   Copyright (C) 1997		Stephan Meyer	[Stephan.Meyer@pobox.com]

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/


/*
* Many thanks go to David Bateman <dbateman@ee.uts.edu.au> et al.
*/

#ifndef __CHIPS_H
#define __CHIPS_H

#define CHIPS_65545		0
#define CHIPS_65548		1
#define CHIPS_65550		2
#define CHIPS_65554		3

#define CHIPS_CRTC_COUNT	24
#define CHIPS_ATC_COUNT		21
#define CHIPS_GRAPHICS_COUNT	9
#define CHIPS_SEQUENCER_COUNT	5
#define CHIPS_EXTENSION_COUNT	128
#define CHIPS_VCLOCK_COUNT	3

typedef struct {
	kgiu8	miscoutput;
	kgiu8	crtc[CHIPS_CRTC_COUNT];
	kgiu8	atc[CHIPS_ATC_COUNT];
	kgiu8	graphics[CHIPS_ATC_COUNT];
	kgiu8	sequencer[CHIPS_SEQUENCER_COUNT];
	kgiu8	extension[CHIPS_EXTENSION_COUNT];
	kgiu8	vclock[CHIPS_VCLOCK_COUNT];
} ChipsRegs;

extern void chips_calcclock(int clock, ChipsRegs *regs);

#endif
